Index: anr/annexe-reponse.tex
===================================================================
--- anr/annexe-reponse.tex	(revision 320)
+++ anr/annexe-reponse.tex	(revision 324)
@@ -7,5 +7,7 @@
 Dans la premiÃšre section, nous prÃ©sentons nos rÃ©ponses aux suggestions et
 remarques des experts en suivant l'ordre du dossier d'Ã©valuation qui nous a Ã©tÃ©
-retournÃ©. La seconde section, quant Ã  elle, synthÃ©tise ces rÃ©ponses.
+retournÃ©. La seconde section, quant Ã  elle, synthÃ©tise nos rÃ©ponses par rapport
+aux principales faiblesses qui ont Ã©tÃ© relevÃ©e pour la prÃ©cÃ©dente version de la
+proposition.
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 \subsection{RÃ©ponses sÃ©quentielles}
@@ -20,18 +22,19 @@
     les environnements industriels QUARTUS \& ISE.
     \t%\note{O.2}
-    Pour la synthÃšse de SoC, on pourrait effectivement utiliser des outils
-    tels \mustbecompleted{XXX ou XXX}.
-    Nous avons choisi DSX/SoCLib, car il est open source, et c'est celui que
+    Pour la synthÃšse de systÃšme, on pourrait effectivement utiliser des outils
+    tels que SOP C builder, mais ceux-ci ne permettent pas de faire de prototypage
+    et ne sont pas libres et trop spÃ©cifiques Ã  une famille d'IPs propriÃ©taire.
+    Nous avons donc choisi DSX/SoCLib, car il est open source, et c'est celui que
     nous maitrisons le plus et nous savons dÃ©jÃ  que son moteur couvre une
     grande partie des besoins de COACH Ã  ce niveau. 
     \t\note{INT}
     Enfin COACH ne vise pas les flots de conception de systÃšmes complexes tels
-    \mustbecompleted{SOCKET, MDA de MAGILLEM, SPEAR-DE ou XXX}.
-    Il se trouvent Ã  un niveau bien infÃ©rieur.
-    Cependant, il est vrai que dans la micro Ã©lectronique d'aujourd'hui ce
-    niveau ne peut Ãªtre ignorÃ©.
-    \textit{Nous avons ajoutÃ© Ã  COACH ce qui est nÃ©cessaire pour qu'il puisse
-    Ãªtre intÃ©grÃ© dans de tels environnements de conception:
-    configuration et description des SoC gÃ©nÃ©rÃ©s en IP-XACT}.
+    que SOCKET, TOPCASED, SPEAR-DE.
+    COACH se positionne en effet comme une sous-partie de ces flots complets et
+    doit Ãªtre considÃ©rÃ© comme un point tool. Cependant, dans la nouvelle
+    version de la proposition, nous avons
+    \textit{ajoutÃ© Ã  COACH ce qui est nÃ©cessaire pour qu'il puisse
+      Ãªtre intÃ©grÃ© dans de tels environnements de conception:
+      configuration et description des SoC gÃ©nÃ©rÃ©s en IP-XACT}.
     Les livrables {\NOVERStrtSpearde} et {\NOVERSmdsAppSpecification} dÃ©montrent cette
     possibilitÃ©.
@@ -39,5 +42,5 @@
     \\ La dimension recherche est prÃ©sente Ã  diffÃ©rents niveaux de ce projet.
     \t%\note{R.1}
-    Tour d'abord, le fait de synthÃ©tiser la mÃªme description de haut niveau soit par HLS
+    Tout d'abord, le fait de synthÃ©tiser la mÃªme description de haut niveau soit par HLS
     soit par ASIP, est Ã  notre connaissance non encore rÃ©alisÃ© Ã  ce jour.
     \t%\note{R.2}
@@ -46,8 +49,6 @@
     \t%\note{R.3}
     \mustbecompleted{je ne comprends pas cet argument}
-	Les IPs sont d'abord des composants matÃ©riels gÃ©nÃ©riques, COACH permettra
-    de concevoir des IPs trÃšs paramÃ©trables (hardware + software), il sera
-    intÃ©ressant de voir ce que de tel IP peuvent apporter Ã  la micro
-    Ã©lectronique.
+	Les IPs courantes du marchÃ© sont des composants matÃ©riels certes gÃ©nÃ©riques mais Ã  configuration/paramÃ©trisation limitÃ©es. COACH permettra au contraire de concevoir des IPs qui constitueront de vÃ©ritables sous-systÃšmes Ã  fonctionnalitÃ©s complexes et trÃšs paramÃ©trables (hardware + software), il sera
+    intÃ©ressant de voir ce que de tel IP peuvent apporter au monde de la conception de systÃšmes embarquÃ©s.
     \t%\note{R.4}
     Les outils de conception de SoC actuels ont soit une approche matÃ©rielle
@@ -64,18 +65,17 @@
   \item[Point 3 (\textit{lien entre HPC et SoC embarquÃ©})]\mbox{}
     \\ %\note{X.1}
-    Le HPC est un terme employÃ© dans tant de contextes qu'il ne veut pas
-    dire grand chose de prÃ©cis. Ce que nous entendons par le terme HPC est
-    spÃ©cifiÃ© section~\ref{HPC:definition} (page~\pageref{HPC:definition}) et
-    le fait que notre HPC est une sur-couche du module de conception de SoC
-    est montrÃ© sur la figure~\ref{coach-flow} (page~\pageref{coach-flow}).\\
+    Le terme HPC est employÃ© dans de nombreux contextes et il est difficile de s'entendre sur sa dÃ©finition exacte. Dans notre proposition, le terme HPC est
+    dÃ©fini section~\ref{HPC:definition} (page~\pageref{HPC:definition}); il
+    s'agit bien d'une sur-couche du module de conception de SoC
+    comme illustrÃ© sur la figure~\ref{coach-flow} (page~\pageref{coach-flow}).\\
     BriÃšvement notre HPC consiste Ã  accÃ©lÃ©rer une application existante qui
     tourne sur un PC. Ceci est fait par:
         1) l'isolation de moteur de calcul de l'application,
         2) l'implantation de ce moteur dans un SoC,
-        3) l'ajout sur le bus PCI/E du PC une carte FPGA.\\
-    Comment COACH aide l'utilisateur Ã  isoler le moteur de calcul de l'application
-    est expliquÃ© dans la section~\ref{HPC:howto} (page~\pageref{HPC:howto}) et
+        3) l'ajout d'une carte FPGA sur le bus PCI/E du PC. Le FPGA intÃšgrera le SoC.\\
+    La faÃ§on dont COACH aide l'utilisateur Ã  isoler le moteur de calcul de l'application
+    est expliquÃ©e dans la section~\ref{HPC:howto} (page~\pageref{HPC:howto}) et
     sur la figure~\ref{archi-hpc} (page~\pageref{archi-hpc}).
-    Comment l'application accÃ©lÃ©rÃ©e est gÃ©nÃ©rÃ©e fait l'objet de la
+    La faÃ§on dont l'application accÃ©lÃ©rÃ©e est gÃ©nÃ©rÃ©e fait l'objet de la
     figure~\ref{coach-flow} (page~\pageref{coach-flow}).
   \item[Autres]\mbox{}
@@ -83,5 +83,5 @@
       \item[Ãtat de l'art incomplet]\mbox{}
         \\ %\note{EA}
-        Dans l'Ã©tat de l'art, nous nous sommes concentrÃ© d'une part sur les outils
+        Dans l'Ã©tat de l'art, nous nous sommes concentrÃ©s d'une part sur les outils
         de mÃªme niveau que COACH,
             le HPC (\sectionVpage{soa:hpc}) et
@@ -107,10 +107,9 @@
         Voir la section \ref{perennite+dissemination} ci-dessous.
       \item[Mauvais positionnement du projet]\mbox{}\\
-        Il Ã©tait mentionnÃ© qu'il aurait mieux fallu positionner le projet
-        en \og plateforme {\fg} plutÃŽt qu'en \og recherche industrielle \fg.
-        Il nous a Ã©tÃ© signifiÃ© que pour projet plateforme, il faut mieux
-        qu'il y ai plusieurs gros industriels leader.
-        Ce n'est pas le cas de ce projet, nous sommes restÃ© en \og recherche
-        industrielle \fg.
+        Concernant la remarque sur un positionnement du projet
+        en \og plateforme {\fg} plutÃŽt qu'en \og recherche industrielle \fg, 
+        nous avons considÃ©rÃ© que l'effort devait Ãªtre concentrÃ© sur les aspects
+techniques innovants plutÃŽt que sur leur mise en application dans un nombre important de flots. En
+effet, dans la nouvelle mouture, nous utilisons les rÃ©sultats des projets SoCket et Topcased, avec compatibilitÃ© IP-XACT, assurant ainsi une gÃ©nÃ©ricitÃ© pour l'intÃ©gration dans de nombreux flots de production, sans pour autant multiplier Ã  outrance les expÃ©rimentations dans le cadre du projet. Ainsi la taille du projet nous permet de rester en positionnement \og recherche industrielle \fg.
     \end{description}
 \end{description}
@@ -135,5 +134,5 @@
     Les experts mentionnent \og une volontÃ© de tout refaire {\fg}. Il est dommage
     qu'ils n'aient pas explicitÃ© leurs pensÃ©es. En effet le projet s'appuie sur
-    des briques existantes pour la plus part de ses composants et sur les
+    des briques existantes pour la plupart de ses composants et sur les
     environnements QUARTUS \& ISE pour la synthÃšse de bas niveau.\\
     Les seuls composants manquants sont les composants matÃ©riels de
@@ -146,12 +145,12 @@
     En effet, le projet n'utilisait pas le standard IP-XACT des flots de
     conception de SoC. Ceci a Ã©tÃ© corrigÃ© dans cette soumission en introduisant
-    le standard IP-XACT (livrable \NOVERScsgImplementation),
+    le standard IEEE 1685 IP-XACT (livrable \NOVERScsgImplementation),
     d'une part en entrÃ©e pour faciliter la configuration de COACH sur d'autre plateforme
-    et d'autre par en ajoutant une sortie au format IP-XACT des SoC gÃ©nÃ©rÃ©s pour
-    leur intÃ©gration comme IP dans d'autres outils de conception de SoC.
+    et d'autre part en ajoutant une sortie au format IP-XACT des SoC gÃ©nÃ©rÃ©s pour
+    leur intÃ©gration comme sous-systÃšme dans les flots de conception de SoC.
     Les livrables {\NOVERStrtSpearde} et {\NOVERSmdsAppSpecification} dÃ©montrent cette
     possibilitÃ©.
-  \item[Utilisation d'RTOS non industriels]\mbox{}\\
-    L'OS bien que indispensable n'est pas une piÃšce maitresse du projet.
+  \item[Utilisation de RTOS non industriels]\mbox{}\\
+    L'OS bien qu'indispensable n'est pas une piÃšce maitresse du projet.
     En effet, on doit pouvoir passer facilement Ã  un autre OS si ce
     dernier supporte les thread POSIX.
@@ -163,5 +162,5 @@
 \begin{description}
     \item[Xilinx n'a pas une part assez active]\mbox{}\\
-        Xilinx ne fait plus parti du consortium.
+        Xilinx ne fait plus partie du consortium.
     \item[Manque un industriel pour assurer la pÃ©rennitÃ©]\mbox{}\\
         \note{IND2}
@@ -176,6 +175,6 @@
 \begin{description}
     \item[IncongruitÃ©s de quelques demandes financiÃšres]\mbox{}\\
-        Les experts n'ont pas prÃ©cisÃ© leurs pensÃ©es, nous ne les avons pas
-        trouvÃ©es et donc pas corrigÃ©es.
+        Les experts n'ont pas prÃ©cisÃ© leurs pensÃ©es. NÃ©anmoins, la rÃ©partition financiÃšre a Ã©tÃ© complÃštement revue.
+
     \item[DÃ©sÃ©quilibre entre l'ampleur du dÃ©veloppement et les moyens]\mbox{}\\
         Voir la section \ref{trop:ambitieux} ci-dessous.
@@ -183,9 +182,6 @@
           un tout cohÃ©rent]\mbox{}\\
         \note{DOU}
-        Cette remarque sous entend que les acadÃ©miques sont incapables de
-        concevoir, dÃ©velopper, maintenir de gros logiciel.
-        Cette remarque est assez tendancieuse, on peut certes trouver beaucoup
-        de projets acadÃ©miques qui n'ont pas abouti mais on peut en trouver
-        encore plus du cÃŽtÃ© des industriels.
+        Un rÃŽle principal de \mds tant que chef de file sera d'assurer la coordination de maniÃšre professionnelle de ce projet.
+        
 \end{description}
 %
@@ -217,11 +213,11 @@
 \subsubsection{Projet trop ambitieux}
 \label{trop:ambitieux}
-Par rapport au projet 2010, on a grandement rÃ©duit la voilure en nous
+Par rapport au projet 2010, nous avons rÃ©duit la surface du projet de 20\% en nous
 concentrant sur le cÅur de COACH. Les principales rÃ©ductions sont:
 \begin{itemize}
   \item Suppression d'un OS:\\
     Dans la proposition 2010, nous avions choisi 2 OS (Mutekh et DNA) pour
-    montrer que COACH Ã©tait assez indÃ©pendant de l'OS. \\
-    L'OS bien que indispensable n'est pas une piÃšce maitresse du projet.
+    montrer que COACH Ã©tait indÃ©pendant de l'OS. 
+    L'OS bien qu'indispensable n'est pas une piÃšce maitresse du projet.
     En effet, on doit pouvoir passer facilement Ã  un autre OS si ce
     dernier supporte les thread POSIX.\\
@@ -238,5 +234,5 @@
   \item Diminution des dÃ©veloppements materiels:\\
     Dans la proposition 2010, nous avions projetÃ© 1) de prototyper les SoC des
-    diffÃ©rentes patrons architecturaux de faÃ§on exacte, 2) d'implanter le
+    diffÃ©rents patrons architecturaux de faÃ§on exacte, 2) d'implanter le
     composant de communication (MWMR) pour les patrons architecturaux XILINX et ALTERA.
     Ces choix conduisaient Ã  4 implantations du composants de communication
@@ -259,10 +255,10 @@
   \item Les descriptions SystemC de 6 composants sur environ 70.
   \item L'explorateur de l'espace de conception DSX qui devra Ãªtre Ã©tendu pour
-    supporter la gÃ©nÃ©ration matÃ©rielle des architectures (VHDL synthÃ©tisablÃ©).
+    supporter la gÃ©nÃ©ration matÃ©rielle des architectures (VHDL synthÃ©tisable).
   \item Un OS sur cinq.
 \end{itemize}
 Cette liste montre clairement que SoCLib n'est qu'un composant logiciel parmi
 la dizaine d'autres sur les quels COACH s'appuie.
-Ce n'est pas et de loin le plus irremplaÃ§able, les modÃšles VHDL du patron
+Ce n'est pas, et de loin, le plus irremplaÃ§able, les modÃšles VHDL du patron
 architectural neutre comme les outils de synthÃšse seraient bien plus difficiles
 Ã  refaire et GCC comme les environnements QUARTUS et ISE sont absolument
@@ -272,5 +268,5 @@
 \t\note{SL3}
 A la question posÃ©e par les experts:
-  \og Faut il financer COACH pour donner une chance Ã  SoCLib? {\fg}
+  \og faut il financer COACH pour donner une chance Ã  SoCLib? {\fg}
 La rÃ©ponse est que financer COACH n'influencera pas la vie de SoCLib,
 les 2 projets n'Ã©tant pas assez corrÃ©lÃ©s.
@@ -280,5 +276,5 @@
 Enfin une rÃ©serve concerne l'utilisation du bus VCI jugÃ© obsolÃšte via les composants
 SoCLib. Le projet prÃ©voit le dÃ©veloppement de pont VCI/AVALON et VCI/\xilinxbus ce qui
-permettra l'utilisation des IP de XILINX et ALTERA dans la patron architectural
+permettra l'utilisation des IP de XILINX et ALTERA dans le patron architectural
 neutre.
 %