Index: anr/section-ressources.tex
===================================================================
--- anr/section-ressources.tex	(revision 353)
+++ anr/section-ressources.tex	(revision 356)
@@ -32,244 +32,403 @@
       devra Ãªtre justifiÃ©e.
 \end{itemize}}
-
+%
 \def\resstablestyletitle#1{\begin{small}{\textit{#1}}\end{small}}
-
-%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
-\subsection{Partner 1: \inria}
-
-\begin{description}
-\item [Equipment]
-  No specific equipment acquisition. 
-\item [Personnel costs] The faculty members involved in the project
-  are FranÃ§ois Charot (INRIA researcher) and Steven Derrien (associate
-  professor). The non-permanent personal required is a PhD
-  student that will mainly work on ASIP generation. We are looking for
-  a profile with strong informatic skills and good knowledge in
-  computer architecture.
-  \parlf
-  The table below summarizes the manpower in \hommemois by tasks for both permanent and
-  non-permanent personnels. The detail by deliverables is given in
-  annexe~\ref{table-livrables-inria} (page \pageref{table-livrables-inria}).
-  The non-permanent personnels costs represent {48\%} of the personnal
-  costs. The requested funding for non permanent personnels is 100\% of
-  the total ANR requested funding.
-    \begin{center}\input{table_inria_cairn_short.tex}\end{center}
-\item [Subcontracting]
-  No subcontracting costs.
-\item [Travel]
-  The travel costs are associated to project meeting as well as participation to
-  conferences. The travel costs are estimated to {7,5\%} of the total
-  requested ANR funding.
-\item [Expenses for inward billing]
-  The costs justified by internal invoicing procedures are evaluated to 4\% of the total
-  requested ANR funding.
-\end{description}
-
-
-\subsection{Partner 2: \lip}
-
-\begin{description}
-\item [Equipment]
-  No specific equipment acquisition. The costs for depreciation of
-  workstations is evaluated to 4\% of the total requested ANR funding.
-\item [Personnel costs] The faculty members involved in the project
-  are Christophe Alias (INRIA researcher) and Paul Feautrier (emeritus
-  professor at ENS-Lyon). The non-permanent personel required is a
-  post-doc that will work on FIFO construction, then on extensions of
-  process construction and memory optimization to non-polyhedral
-  loops.  We are looking for a candidate with both theoretical and
-  practical skills, that will be able to get a sufficient
-  understanding of the polyhedral techniques to produce a working
-  implementation.
-  \parlf
-  The table below summarizes the \hommemois by tasks for both permanent
-  and non-permanent personnels.
-  Annexe~\ref{table-livrables-lip} (page \pageref{table-livrables-lip})
-  details this table at the deliverable level.
-  The effort of permanent personnels represents 61\% of
-  the total effort. The non-permanent personnels costs represents
-  52\% of the personal costs. The requested funding for non permanent
-  personnels is 100\% of the total ANR requested
-  funding.
-  \begin{center}\input{table_inria_compsys_short.tex}\end{center}
-\item [Subcontracting]
-  No subcontracting costs.
-\item [Travel]
-  The travel costs are associated to project meeting as well as
-  participation to conferences. The travel costs are estimated to 20\%
-  of the total requested ANR funding.
-\item [Expenses for inward billing]
-  The costs justified by internal invoicing procedures are evaluated
-  to 4\% of the total requested ANR funding.
-\end{description}
-
-%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
-\subsection{Partner 3: \tima}
-
-\begin{description}
-\item [Equipment]
-  No specific equipment acquisition. 
-\item [Personnel costs]
-  The permanent personnels involved in the project are professor and associate professor
-  (Fr\'ed\'eric P\'etrot and Olivier Muller).
-  The non permanent personnels are Phd students and post-doc researchers.
-  Related costs are estimated in \hommemois.
-  One phd student (Adrien Prost-Boucle), funded by the French ministry of research, will
-  be working on the project.
-  One 100\% funded phd student will be hired in September 2011. A post-doc researcher will
-  be hired at the end of 2012 for one year.
-  The PhD student will mainly work on the evolution of UGH HLS tool. Thus, we are looking
-  for a profile with strong informatic skills and good knowledge in computer architecture.
-  The post-doc will mainly work on HPC. The required profile
-  will be more oriented on computer architecture and advanced digital design.
-  \parlf
-  The table below summarizes the man power in \hommemois by tasks for both permanent and
-  non-permanent personnels. The detail by deliverables is given in
-  annexe~\ref{table-livrables-tima} (page \pageref{table-livrables-tima}).
-  The effort of permanent personnels represents 50\% of the total effort.
-  The requested funding for non permanent personnels is 86\% of the total ANR requested
-  funding.
-    \begin{center}\input{table_tima_short.tex}\end{center}
-\item [Subcontracting]
-  No subcontracting costs.
-\item [Travel]
-  The travel costs are associated to project meeting as well as participation to
-  conferences. The travel costs are estimated to 10\% of the total requested ANR funding.
-\item [Expenses for inward billing]
-  The costs justified by internal invoicing procedures are evaluated to 4\% of the total
-  requested ANR funding.
-\end{description}
-
-%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
-\subsection{Partner 4: \ubs}
-
-\begin {description}
-\item [Equipment]
-  In order to validate the design flow project, the Lab-STICC laboratory will buy FPGA
-  developpement boards.  The cost for these FPGA boards is estimated to 3\% of the total
-  ANR funding.
-\item [Personnel costs]
-  The faculty members involved in the project are associate professors (Philippe COUSSY,
-  Cyrille CHAVET) or research engineers (Dominique HELLER). All non-permanent personnel
-  costs are estimated in \hommemois for senior researchers (post-doc or research
-  engineers).
-  \parlf
-  The table below sumarizes the man power in \hommemois by tasks for both permanent and
-  non-permanent personnels. The detail by deliverables is given in 
-  annexe~\ref{table-livrables-usb} (page \pageref{table-livrables-usb}).
-  The non-permanent personnels costs represent 50\% of the personnal costs.
-  The requested funding for non permanent personnels is about 83\% of the total ANR
-  requested funding.
-    \begin{center}\input{table_ubs_short.tex}\end{center}
-\item [Subcontracting]
-  No subcontracting costs.
-\item [Travel]
-  The travel costs are associated to management and meeting as well as participation to
-  conferences. The travel costs are estimated to 10\% of the total requested ANR funding.
-\item [Expenses for inward billing]
-  The costs justified by internal invoicing procedures are evaluated to 4\% of the total
-  requested ANR funding.
-\end {description}
-
-
-%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
-\subsection{Partner 5: \upmc}
-
-\begin{description}
-\item[Equipment]
-    No specific equipment acquisition is required for this project. 
-    The costs for depreciation of workstations and pre-existing FPGA boards are evaluated
-    to 7\% of the total requested ANR funding.
-\item[Personnel costs]
-    The permanent personnels involved in the project are professors or assistant
-    processors (Alain Greiner and Ivan Aug\'e).
-    All non permanent personnel costs are estimated in \hommemois for senior researchers
-    (post-doc or research engineers).
-    The table below sumarizes the man power by tasks in \hommemois for both permanent  and
-    non-permanent personnels.
-    The detail by deliverables is given in annexe~\ref{table-livrables-upmc} (page \pageref{table-livrables-upmc}).
-    The non-permanent personnels costs (24 \hommemois) represent 46\% of the personnal costs.
-    The requested funding for non permanent personnels is 79\% of the total ANR
-    requested funding.
-    \begin{center}\input{table_upmc_short.tex}\end{center}
-\item[Subcontracting]
-    No subcontracting costs.
-\item[Travel]
-    The travel costs are associated to management and coordination meeting as
-    well as participation to conferences. The travel costs are estimated
-    to 10\% of the total requested ANR funding.
-\item[Expenses for inward billing]
-    The costs justified by internal invoicing procedures are evaluated to 4\%
-    of the total requested ANR funding.
-\end{description}
-
-%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
-\subsection{Partner 6: \mdslong}
-
-\begin{description}
-\item[Equipment]
-  No specific equipment acquisition is required for this project. 
-\item[Personnel costs]
+%
+\def\ressources#1#2#3#4#5{{%
+    \def\tmp{}
+    \begin{description}
+        \setlength{\itemsep}{1pt}
+        \setlength{\parskip}{0pt}
+        \setlength{\parsep}{0pt}
+        \item[Equipment]
+            \def\cont{#2}
+            \ifx\cont\tmp\def\cont{No specific equipment acquisition is required for this project.}\fi
+            \cont
+        \item[Personnel costs]
+            #3\\
+            \begin{minipage}{\linewidth}\center\input{table_#1_short.tex}\end{minipage}
+        \item[Subcontracting] No subcontracting costs.
+        \item[Travel]
+            The travel costs are associated to project meeting as well as participation to
+            conferences. The travel costs are estimated to #4\% of the total requested ANR funding.
+        \item[Expenses for inward billing]
+            \def\cont{#5}
+            \ifx\cont\tmp\def\cont{None.}\else\def\cont{%
+              The costs justified by internal invoicing procedures are evaluated
+              to #5\% of the total requested ANR funding.}\fi
+              \cont
+        %\item[Other working costs] None
+    \end{description}
+}}
+
+\newcount\mycnt
+\def\AcademicPersonalCost#1#2#3#4#5#6#7{
+   \mycnt=#4\multiply\mycnt100\divide\mycnt#3
+   The #2 effort is \textbf{#3} \hommemois, the table below details it by tasks and the
+   table in annexe~\ref{table-livrables-#1} (page \pageref{table-livrables-#1})
+   details it by deliverables.
+   The permanent personnels are #5.
+   The effort due to the non permanent personnels is \textbf{#4} \hommemois
+   (\textbf{\the\mycnt\%} of the total effort).
+   %All non permanent personnel costs are estimated in \hommemois for senior researchers (post-doc or research engineers).
+   The requested funding for non permanent personnels is \textbf{#6\%} of the total ANR
+   requested funding.
+   #7
+}
+\def\ressourcesForAcademic#1#2#3#4#5{
+  \ressources{#1}{#2}{\AcademicPersonalCost{#1}#3}{#4}{#5}
+}
+%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+
+The global effort is 358 \hommemois (\hommemoislong),
+the part of academic partners is 236 \hommemois (66\% of the global effort)
+and the part of the industrial partners is 122 \hommemois (\textbf{34\%} of the
+global effort).
+The tables of annexe~\ref{effort:by:livrable} gives this global effort by deliverables,
+those of annexe~\ref{effort:by:partner:livrable} shows this global effort by partner and
+deliverables.\\
+\textbf{NOTICE:} In these tables and in the following sections the units is the
+\hommemois of a senior researcher (post-doc or research engineers).
+
+%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+\subsection{Partner 1: \mdslong}
+\ressources{mds}
+  {}
+  {
   \mds employees involved in the project are permanent managers, engineers and PhD graduates.
   The man power detail in \hommemois by deliverables is given in
   annexe~\ref{table-livrables-mds} (page \pageref{table-livrables-mds}).
-  and a sumary by task in the following table.
-  \begin{center}\input{table_mds_short.tex}\end{center}
-\item[Subcontracting]
-  No subcontracting costs.
-\item[Travel]
-  The travel costs are associated to project meeting as well as participation to
-  conferences. The travel costs are estimated to 2\% of the total requested ANR funding.
-\item[Expenses for inward billing] none
-\item[Other working costs] none
-\end{description}
-
+  and a summary by task in the following table.
+   \mustbecompleted{\\MDS: Vous n'etes dans aucuns projets annexe 7.3 ?}
+  }
+  {2}
+  {}
+%  
+% \begin{description}
+% \item[Equipment]
+%   No specific equipment acquisition is required for this project. 
+% \item[Personnel costs]
+%   \mds employees involved in the project are permanent managers, engineers and PhD graduates.
+%   The man power detail in \hommemois by deliverables is given in
+%   annexe~\ref{table-livrables-mds} (page \pageref{table-livrables-mds}).
+%   and a sumary by task in the following table.
+%   \begin{center}\input{table_mds_short.tex}\end{center}
+% \item[Subcontracting]
+%   No subcontracting costs.
+% \item[Travel]
+%   The travel costs are associated to project meeting as well as participation to
+%   conferences. The travel costs are estimated to 2\% of the total requested ANR funding.
+% \item[Expenses for inward billing] none
+% \item[Other working costs] none
+% \end{description}
+
+%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+\subsection{Partner 2: \upmc}
+\ressourcesForAcademic
+  {upmc}
+  { In order to validate the COACH design flow, \upmc will buy FPGA development
+    boards (especially 1  PCI/E FPGA \xilinx board).
+    The cost for these boards is estimated to 4500 \euro (3\% of the total ANR funding).}
+  {{\upmc}{52}{24}{Alain Greiner and Ivan Aug\'e}{87}{
+     We are looking for a profile with strong skills in SW development and good
+     knowledge in SoC design and virtual prototyping.
+   }}
+  {7}{3.5}
+% 
+% \begin{description}
+% \item[Equipment]
+%     In order to validate the COACH design flow, \upmc will buy FPGA development
+%     boards (especially 1  PCI/E FPGA \xilinx board).
+%     The cost for these boards is estimated to 6 k\euro (4\% of the total ANR funding).
+% \item[Personnel costs]
+%     The permanent personnels involved in the project are professors or assistant
+%     professors (Alain Greiner and Ivan Aug\'e).
+%     All non permanent personnel costs are estimated in \hommemois for senior researchers
+%     (post-doc or research engineers).
+%     The table below sumarizes the man power by tasks in \hommemois for both permanent  and
+%     non-permanent personnels.
+%     The detail by deliverables is given in annexe~\ref{table-livrables-upmc} (page \pageref{table-livrables-upmc}).
+%     The non-permanent personnels costs (24 \hommemois) represent 46\% of the personnal costs.
+%     The requested funding for non permanent personnels is 79\% of the total ANR
+%     requested funding.
+%     \begin{center}\input{table_upmc_short.tex}\end{center}
+% \item[Subcontracting]
+%     No subcontracting costs.
+% \item[Travel]
+%     The travel costs are associated to management and coordination meeting as
+%     well as participation to conferences. The travel costs are estimated
+%     to 10\% of the total requested ANR funding.
+% \item[Expenses for inward billing]
+%     The costs justified by internal invoicing procedures are evaluated to 4\%
+%     of the total requested ANR funding.
+% \end{description}
+
+%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+\def\t{\hspace*{.5cm}}
+\subsection{Partner 3: \ubs}
+\ressourcesForAcademic
+  {ubs}
+  { In order to validate the design flow project, the Lab-STICC laboratory will buy FPGA
+    development boards.  The cost for these FPGA boards is estimated to 3\% of the total
+    ANR funding.
+    \mustbecompleted{INCOHERENCE avec SITE ANR}
+  }
+  {{\ubs}{48}{24}{Philippe COUSSY, Cyrille CHAVET and Dominique HELLER}{83}{
+   \mustbecompleted{\\UBS: A) manque 1 profil ici, B) dans annexe 7.2 il ne faut que 5
+   publis de moins de 5 ans, C) Vous n'etes dans aucuns projets annexe 7.3 ?}
+   \mustbecompleted{\\UBS:  ./gantt < anr.gant\\
+   \t WARNING: ubs       :D511 probleme sur l'an 1 (in table=7.0, in gantt=6.0 \\
+   \t ERROR:   ubs       :D840 probleme sur l'an 1 (in table=0.5, in gantt=0.0}
+  }}
+  {10}{4}
+
+% \begin {description}
+% \item [Equipment]
+%   In order to validate the design flow project, the Lab-STICC laboratory will buy FPGA
+%   development boards.  The cost for these FPGA boards is estimated to 3\% of the total
+%   ANR funding.
+% \item [Personnel costs]
+%   The faculty members involved in the project are associate professors (Philippe COUSSY,
+%   Cyrille CHAVET) or research engineers (Dominique HELLER). All non-permanent personnel
+%   costs are estimated in \hommemois for senior researchers (post-doc or research
+%   engineers).
+%   \parlf
+%   The table below summarizes the man power in \hommemois by tasks for both permanent and
+%   non-permanent personnels. The detail by deliverables is given in 
+%   annexe~\ref{table-livrables-usb} (page \pageref{table-livrables-usb}).
+%   The non-permanent personnels costs represent 50\% of the personnel costs.
+%   The requested funding for non permanent personnels is about 83\% of the total ANR
+%   requested funding.
+%     \begin{center}\input{table_ubs_short.tex}\end{center}
+% \item [Subcontracting]
+%   No subcontracting costs.
+% \item [Travel]
+%   The travel costs are associated to management and meeting as well as participation to
+%   conferences. The travel costs are estimated to 10\% of the total requested ANR funding.
+% \item [Expenses for inward billing]
+%   The costs justified by internal invoicing procedures are evaluated to 4\% of the total
+%   requested ANR funding.
+% \end {description}
+
+%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+\subsection{Partner 4: \liplong}
+\ressourcesForAcademic
+ {inria_compsys}{}
+ {{\lip}{46}{22}{Christophe Alias and Paul Feautrier}{100}{
+   \\We are looking for a candidate with both theoretical and
+   practical skills, that will be able to get a sufficient
+   understanding of the polyhedral techniques.
+   \mustbecompleted{\\LIP: DANS FIG.8 vous avez 28 hm. 46-28=18 --> 40\%\\
+   IL FAUT ETRE <= 50\%, le max de non permanent est 23.}
+   \mustbecompleted{\\LIP: Vous n'etes dans aucuns projets annexe 7.3 ?}
+   \mustbecompleted{\\LIP: ./gantt < anr.gant\\
+   \t WARNING: lip       :D432 probleme sur l'an 2 (in table=7.0, in gantt=6.0 \\
+   \t WARNING: lip       :D432 probleme sur l'an 3 (in table=13.0, in gantt=12.0\\
+   \t ERROR:   lip       :D730 probleme sur l'an 3 (in table=0.0, in gantt=3.0}
+   }}
+ {\mustbecompleted{(LIP: ca fait beaucoup) }20}{4}
+%
+% \begin{description}
+% \item [Equipment]
+%   No specific equipment acquisition. The costs for depreciation of
+%   workstations is evaluated to 4\% of the total requested ANR funding.
+% \item [Personnel costs] The faculty members involved in the project
+%   are Christophe Alias (INRIA researcher) and Paul Feautrier (emeritus
+%   professor at ENS-Lyon). The non-permanent personel required is a
+%   post-doc that will work on FIFO construction, then on extensions of
+%   process construction and memory optimization to non-polyhedral
+%   loops.  We are looking for a candidate with both theoretical and
+%   practical skills, that will be able to get a sufficient
+%   understanding of the polyhedral techniques to produce a working
+%   implementation.
+%   \parlf
+%   The table below summarizes the \hommemois by tasks for both permanent
+%   and non-permanent personnels.
+%   Annexe~\ref{table-livrables-lip} (page \pageref{table-livrables-lip})
+%   details this table at the deliverable level.
+%   The effort of permanent personnels represents 61\% of
+%   the total effort. The non-permanent personnels costs represents
+%   52\% of the personal costs. The requested funding for non permanent
+%   personnels is 100\% of the total ANR requested
+%   funding.
+%   \begin{center}\input{table_inria_compsys_short.tex}\end{center}
+% \item [Subcontracting]
+%   No subcontracting costs.
+% \item [Travel]
+%   The travel costs are associated to project meeting as well as
+%   participation to conferences. The travel costs are estimated to 20\%
+%   of the total requested ANR funding.
+% \item [Expenses for inward billing]
+%   The costs justified by internal invoicing procedures are evaluated
+%   to 4\% of the total requested ANR funding.
+% \end{description}
+
+%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+\subsection{Partner 5: \tima}
+\ressourcesForAcademic
+  {tima}{}
+  {{\tima}{48}{24}{Fr\'ed\'eric P\'etrot, Olivier Muller and Adrien Prost-Boucle}{86}{
+    \\One 100\% funded phd student will be hired in September 2011, we are looking
+    for a profile with strong informatic skills and good knowledge in computer architecture.
+    A post-doc researcher will be hired at the end of 2012 for one year, the
+    required profile will be more oriented on computer architecture and
+    advanced digital design.
+    \mustbecompleted{\\TIMA: \begin{itemize}
+      \item chiffre delirant: dans figure 8 vous avez 52 hm ??? vous devez avoir 24.
+      \item vous dites ci dessus que vous embauchez pour 50 hm, hors l'effort
+      des non permanent est 24 ???
+    \end{itemize}\mbox{}}
+    }}
+ {10}{4}
+%
+% \begin{description}
+% \item [Equipment]
+%   No specific equipment acquisition. 
+% \item [Personnel costs]
+%   The permanent personnels involved in the project are professor and associate professor
+%   (Fr\'ed\'eric P\'etrot and Olivier Muller).
+%   The non permanent personnels are Phd students and post-doc researchers.
+%   Related costs are estimated in \hommemois.
+%   One phd student (Adrien Prost-Boucle), funded by the French ministry of research, will
+%   be working on the project.
+%   One 100\% funded phd student will be hired in September 2011.
+%   A post-doc researcher will be hired at the end of 2012 for one year.
+%   The PhD student will mainly work on the evolution of UGH HLS tool. Thus, we are looking
+%   for a profile with strong informatic skills and good knowledge in computer architecture.
+%   The post-doc will mainly work on HPC. The required profile
+%   will be more oriented on computer architecture and advanced digital design.
+%   \parlf
+%   The table below summarizes the man power in \hommemois by tasks for both permanent and
+%   non-permanent personnels. The detail by deliverables is given in
+%   annexe~\ref{table-livrables-tima} (page \pageref{table-livrables-tima}).
+%   The effort of permanent personnels represents 50\% of the total effort.
+%   The requested funding for non permanent personnels is 86\% of the total ANR requested
+%   funding.
+%     \begin{center}\input{table_tima_short.tex}\end{center}
+% \item [Subcontracting]
+%   No subcontracting costs.
+% \item [Travel]
+%   The travel costs are associated to project meeting as well as participation to
+%   conferences. The travel costs are estimated to 10\% of the total requested ANR funding.
+% \item [Expenses for inward billing]
+%   The costs justified by internal invoicing procedures are evaluated to 4\% of the total
+%   requested ANR funding.
+% \end{description}
+
+%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+\subsection{Partner 6: \inria}
+\ressourcesForAcademic
+ {inria_cairn}{}
+ {{\inria}{42}{20}{ FranÃ§ois Charot and Steven Derrien}{100}{
+    We are looking for a profile with strong skills in SW development and good
+    knowledge in computer architecture.
+   \mustbecompleted{\\IRISA figure 8 vous avez 18 hm vous devez avoir 22.}
+   \mustbecompleted{\\IRISA: Vous n'etes dans aucuns projets annexe 7.3 ?}
+   \mustbecompleted{\\IRISA: ./gantt < anr.gant\\
+     \t ERROR:   inria     :D420 probleme sur l'an 3 (in table=0.0, in gantt=3.0}
+    }}
+ {7.5}{4}
+% 
+% \begin{description}
+% \item [Equipment]
+%   No specific equipment acquisition. 
+% \item [Personnel costs] The faculty members involved in the project
+%   are FranÃ§ois Charot (INRIA researcher) and Steven Derrien (associate
+%   professor).
+%   The non-permanent personal required is a PhD
+%   student that will mainly work on ASIP generation. We are looking for
+%   a profile with strong informatic skills and good knowledge in
+%   computer architecture.
+%   \parlf
+%   The table below summarizes the manpower in \hommemois by tasks for both permanent and
+%   non-permanent personnels. The detail by deliverables is given in
+%   annexe~\ref{table-livrables-inria} (page \pageref{table-livrables-inria}).
+%   The non-permanent personnels costs represent {48\%} of the personnal
+%   costs. The requested funding for non permanent personnels is 100\% of
+%   the total ANR requested funding.
+%     \begin{center}\input{table_inria_cairn_short.tex}\end{center}
+% \item [Subcontracting]
+%   No subcontracting costs.
+% \item [Travel]
+%   The travel costs are associated to project meeting as well as participation to
+%   conferences. The travel costs are estimated to {7,5\%} of the total
+%   requested ANR funding.
+% \item [Expenses for inward billing]
+%   The costs justified by internal invoicing procedures are evaluated to 4\% of the total
+%   requested ANR funding.
+% \end{description}
 
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 \subsection{Partner 7: \bull}
-\begin{description}
-\item[Equipment]
-    Acquisition of a FPGA development board will represent the main equipment cost for
+\ressources
+  {bull}
+  { Acquisition of a FPGA development board will represent the main equipment cost for
     Bull in COACH. It is estimated at about 5\% (tbc) of the total funding.
-\item[Personnel costs]
-    A permanent engineer will be assigned full time to the project for a duration of 36
-    months as shown in the table below that summarizes the man power in \hommemois.
-    The detail  by deliverables is given in
+    \mustbecompleted{INCOHERENCE avec SITE ANR}
+    }
+  {
+    The man power detail in \hommemois by deliverables is given in
     annexe~\ref{table-livrables-bull} (page \pageref{table-livrables-bull}).
-    \begin{center}\input{table_bull_short.tex}\end{center}
-\item[Subcontracting]
-    No subcontracting costs.
-\item[Travel]
-    Application of a standard 10\% of the total funding to travel costs.
-\item[Expenses for inward billing]
-    Costs justified by inward billing are estimated to about 5\% of the total funding.
-\item[Other working costs] none
-\end{description}
+    and a summary by task in the following table.
+    \bull employees involved in the project are a manager for 9 \hommemois
+    and an engineer  for 27 \hommemois.}
+  {10}{5}
+
+% \begin{description}
+% \item[Equipment]
+%     Acquisition of a FPGA development board will represent the main equipment cost for
+%     Bull in COACH. It is estimated at about 5\% (tbc) of the total funding.
+% \item[Personnel costs]
+%     A permanent engineer will be assigned full time to the project for a duration of 36
+%     months as shown in the table below that summarizes the man power in \hommemois.
+%     The detail  by deliverables is given in
+%     annexe~\ref{table-livrables-bull} (page \pageref{table-livrables-bull}).
+%     \begin{center}\input{table_bull_short.tex}\end{center}
+% \item[Subcontracting]
+%     No subcontracting costs.
+% \item[Travel]
+%     Application of a standard 10\% of the total funding to travel costs.
+% \item[Expenses for inward billing]
+%     Costs justified by inward billing are estimated to about 5\% of the total funding.
+% \item[Other working costs] none
+% \end{description}
 
 
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 \subsection{Partner 8: \thales}
-
-\begin{description}
-\item[Equipment]
-    In order to validate the design flow,TRT will buy FPGA developpement boards. The cost
-    for these FPGA boards is estimated to 10 k\euro (6\% of the total ANR funding).
-\item[Personnel costs]
-    The effort to adapt SPEAR DE to generate the input files to COACH framework is
-    estimated to 13 \hommemois.
-    The effort to describe and develop the application is estimated to 14 \hommemois.
-    Finally we need one man*month for the participation to the global specification in task 2.
-    This is summarized in the table below and detailed by deliverables in 
+\ressources
+  {thales}
+  { In order to validate the design flow,TRT will buy FPGA developpement boards. The cost
+    for these FPGA boards is estimated to 11 k\euro (6\% of the total ANR funding).
+    \mustbecompleted{INCOHERENCE avec SITE ANR}
+    }
+  { The man power detail in \hommemois by deliverables is given in
     annexe~\ref{table-livrables-thales} (page \pageref{table-livrables-thales}).
-    \begin{center}\input{table_thales_short.tex}\end{center}
-\item[Subcontracting]
-    No subcontracting costs.
-\item[Travel]
-    The travel costs are associated to meeting, plenaries as well as participation to
-    conferences. The travel costs are estimated to 10 k\euro. The travel costs are estimated to
-    5\% of the total requested ANR funding.
-\item[Expenses for inward billing] none
-\item[Other working costs] none
-\end{description}
+    and a summary by task in the following table.
+    \thales employees involved in the project are a manager for 18 \hommemois
+    and an engineer  for 18 \hommemois.}
+  {5}{}
+
+% \begin{description}
+% \item[Equipment]
+%     In order to validate the design flow,TRT will buy FPGA developpement boards. The cost
+%     for these FPGA boards is estimated to 10 k\euro (6\% of the total ANR funding).
+% \item[Personnel costs]
+%     The effort to adapt SPEAR DE to generate the input files to COACH framework is
+%     estimated to 13 \hommemois.
+%     The effort to describe and develop the application is estimated to 14 \hommemois.
+%     Finally we need one man*month for the participation to the global specification in task 2.
+%     This is summarized in the table below and detailed by deliverables in 
+%     annexe~\ref{table-livrables-thales} (page \pageref{table-livrables-thales}).
+%     \begin{center}\input{table_thales_short.tex}\end{center}
+% \item[Subcontracting]
+%     No subcontracting costs.
+% \item[Travel]
+%     The travel costs are associated to meeting, plenaries as well as participation to
+%     conferences. The travel costs are estimated to 10 k\euro. The travel costs are estimated to
+%     5\% of the total requested ANR funding.
+% \item[Expenses for inward billing] none
+% \item[Other working costs] none
+% \end{description}
 
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%